#ifndef __sockrpc_HXX
#include "sockrpc.hxx"
#endif

#ifndef __callbackserver_svc_HXX
#define __callbackserver_svc_HXX

//  YOODA : Yet another Object Oriented Database
//    Copyright (C) 1994  Eric Abecassis

// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.

// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the Free
// Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 


#ifdef __GNUG__
#pragma interface
#endif

class CallbackServer : public SvcServer {
  public :
  CallbackServer(int family=AF_INET) : SvcServer("CallbackServer", family) {};
  CallbackServer(char* n, int f) : SvcServer(n,f) {}

  public :
  int askLock(const PID& pid) ;

  public :

  class ReqRegister_askLock {
    public :
    int dummy ;
    ReqRegister_askLock(SvcServer* svc = SvcServer::_svcBase) {
      svc->reqRegister(CallbackServer::svc_askLock,0);
    } 
  } req_askLock ;
  static void svc_askLock(SvcSocket& __svc) {
    PID pid ;
    __svc >> pid ;
    __svc << ( ((CallbackServer*)(&__svc))->askLock(pid) ) << svcflush ;
  } ;
} ;


#endif
